% myLu.m 
%       Calculates a LU Decomposition of a regular nxn matrix A
% input: regular nxn matrix A
% output: L,R s.t. A = L*R

function [L, R] = myLu(A)

%get dimension and allocate memory
n = size(A,1);
L = eye(n);

for k=1:n
    for i=k+1:n
        L(i,k) = A(i,k) / A(k,k);
        for j=k+1:n
           A(i,j) = A(i,j) - L(i,k)*A(k,j);
        end        
        A(i,k) = 0;
    end
end

R = A;