clear all;
close all;
clc;

tol = 1e-12;
maxit = 5000;

%testcase 1
A = [2 -1 0 0; -1 2 -1 0; 0 -1 2 -1; 0 0 -1 2];
b = [1; 0 ; -1; -1];
x0 = ones(4,1);
[x_j, nit_j] = iterationMethod(A,b,x0,tol,maxit,'jacobi');
[x_gs, nit_gs] = iterationMethod(A,b,x0,tol,maxit,'gauss-seidel');
x = A\b;

err_j = max(abs(x-x_j));
err_gs = max(abs(x-x_gs));

fprintf('Testcase 1:\n')
fprintf('\tError with resp. to x_exact\n')
fprintf('\t   gauss-seidel: %d\n',err_gs)
fprintf('\t   jacobi: %d\n',err_j)
fprintf('\n\tIterations (nit)\n')
fprintf('\t   Gauss-Seidel: %d\n ',nit_gs)
fprintf('\t   Jacobi: %d\n',nit_j)


%testcase 2
A = [1 2 -2 2; 1 1 1 0; 2 2 1 2; -1 -2 1 1];
b = [1; 4 ; -1; -1];
x0 = ones(4,1);
[x_j, nit_j] = iterationMethod(A,b,x0,tol,maxit,'jacobi');
[x_gs, nit_gs] = iterationMethod(A,b,x0,tol,maxit,'gauss-seidel');
x = A\b;

err_j = max(abs(x-x_j));
err_gs = max(abs(x-x_gs));

fprintf('\nTestcase 2:\n')
fprintf('\tError with resp. to x_exact\n')
fprintf('\t   gauss-seidel: %d\n',err_gs)
fprintf('\t   jacobi: %d\n',err_j)
fprintf('\n\tIterations (nit)\n')
fprintf('\t   Gauss-Seidel: %d\n ',nit_gs)
fprintf('\t   Jacobi: %d\n',nit_j)


%testcase 3
A = [3 -2 -1 1; 1 2 -2 1; 1 -2 2 2; 1 -2 1 1];
b = [1; 4 ; -1; -1];
x0 = ones(4,1);
[x_j, nit_j] = iterationMethod(A,b,x0,tol,maxit,'jacobi');
[x_gs, nit_gs] = iterationMethod(A,b,x0,tol,maxit,'gauss-seidel');
x = A\b;

err_j = max(abs(x-x_j));
err_gs = max(abs(x-x_gs));

fprintf('\nTestcase 3:\n')
fprintf('\tError with resp. to x_exact\n')
fprintf('\t   gauss-seidel: %d\n',err_gs)
fprintf('\t   jacobi: %d\n',err_j)
fprintf('\n\tIterations (nit)\n')
fprintf('\t   Gauss-Seidel: %d\n ',nit_gs)
fprintf('\t   Jacobi: %d\n',nit_j)

